# KONG, FAST API & MYSQL

This is a project to create a docker container for MySQL and Python.

Using FAST API and MySQL Connector.

Make sure you have Docker installed and create the network so all of the container able to communicate.
> docker network create kongkong

## Run WSL on VSCode

> code .

So I run the docker on wsl, and make the file editing easier by also run it from VSCode.

This is not necessary, you can run it from everywhere.

# RUN MYSQL CONTAINER
1. Run the container:

> docker run -d \
--network kongkong \
--name mysql \
-v conf_data:/etc/mysql/conf.d \
-v db_data:/var/lib/mysql \
-e MYSQL_ROOT_PASSWORD= password \
-e MYSQL_DATABASE= mydb \
-e MYSQL_PASSWORD= password \
mysql

The long version:
> docker run -d --network kongkong --name mysql -v conf_data:/etc/mysql/conf.d -v db_data:/var/lib/mysql -e MYSQL_ROOT_PASSWORD=password -e MYSQL_DATABASE=mydb -e MYSQL_PASSWORD=password mysql

Reading material for Volume on MYSQL:
https://phoenixnap.com/kb/mysql-docker-container#ftoc-heading-7


2. Check the ip of mysql container to be used as host in main.py for fastapi.

> docker inspect -f '{{range.NetworkSettings.Networks}}{{.IPAddress}}{{end}}' mysql

result: 172.19.0.2

put it on python file configuration mine is on main.py: host = '172.19.0.2'

or 

> docker inspect mysql

3. Execute MYSQL container.

> docker exec -it [container name] mysql -u root -p 

or

> docker exec -it a727cabd05d4 mysql -u root -p 

# RUN FAST API CONTAINER

1. Create requirements.txt that contains necessities for your Python program, FastAPI, and Python connector.

2. Create Dockerfile.

3. Create main.py.

4. Build image

> docker build --tag  fsqlkong .

I run it on /datavizz/fastsql directory and fsqlkong is the name of the image.

5. Scan Image

> docker scan fsqlkong

6. Run the app docker

The port must be similar with port in dockerfile.

If you need to make a change, you need to rebuild the image and re run the container.

Don't forget to delete the existing image and remove the existing container if you want to rebuild it again.

> docker run -dit --name fastsqlkong -p 3000:3000 --network kongkong fsqlkong

# RUN KONG CONTAINER IN DB-LESS MODE
1. Check the host for FastAPI container
> docker inspect -f '{{range.NetworkSettings.Networks}}{{.IPAddress}}{{end}}' fastsqlkong

host results:

172.19.0.3

But still can use this one asthe host I guess:

host.docker.internal

2. Prepare the declarative configuration file for Kong.

file name: kong.yml
Create service and also the routes.

3. Run the Docker for Kong

docker run -it --name kong-dbless-api 
> --network=kongkong \
  -v "$(pwd):/datavizz/webproject/" \
  -e "KONG_DATABASE=off" \
  -e "KONG_DECLARATIVE_CONFIG=/datavizz/webproject/kong.yml" \
  -e "KONG_PROXY_ACCESS_LOG=/dev/stdout" \
  -e "KONG_ADMIN_ACCESS_LOG=/dev/stdout" \
  -e "KONG_PROXY_ERROR_LOG=/dev/stderr" \
  -e "KONG_ADMIN_ERROR_LOG=/dev/stderr" \
  -e "KONG_ADMIN_LISTEN=0.0.0.0:8001, 0.0.0.0:8444 ssl" \
  -p 8000:8000 \
  -p 8443:8443 \
  -p 127.0.0.1:8001:8001 \
  -p 127.0.0.1:8444:8444 \
  kong:2.8.1-alpine 

OR:

> docker run --name kong-dbless-api  --network=kongkong  -v "$(pwd):/datavizz/webproject"  -e "KONG_DATABASE=off"  -e "KONG_DECLARATIVE_CONFIG=/datavizz/webproject/kong.yml"  -e "KONG_PROXY_ACCESS_LOG=/dev/stdout"  -e "KONG_ADMIN_ACCESS_LOG=/dev/stdout"  -e "KONG_PROXY_ERROR_LOG=/dev/stderr"  -e "KONG_ADMIN_ERROR_LOG=/dev/stderr"  -e "KONG_ADMIN_LISTEN=0.0.0.0:8001, 0.0.0.0:8444 ssl"  -p 8000:8000  -p 8443:8443  -p 127.0.0.1:8001:8001  -p 127.0.0.1:8444:8444  kong:2.8.1-alpine

# RUN KONG CONTAINER WITH DB MODE

1. Start PostgreSQL Container
>  docker run -d --name kong-database \
  --network=kongkong \
  -p 5432:5432 \
  -e "POSTGRES_USER=kong" \
  -e "POSTGRES_DB=kong" \
  -e "POSTGRES_PASSWORD=kongpass" \
  postgres:9.6

  OR:
  > docker run -d --name kong-database --network=kongkong -p 5432:5432 -e "POSTGRES_USER=kong" -e "POSTGRES_DB=kong" -e "POSTGRES_PASSWORD=kongpass" postgres:9.6

2. Prepare Kong Database
> docker run --rm --network=kongkong \
  -e "KONG_DATABASE=postgres" \
  -e "KONG_PG_HOST=kong-database" \
  -e "KONG_PG_PASSWORD=kongpass" \
 kong:latest kong migrations bootstrap

 OR:
 > docker run --rm --network=kongkong -e "KONG_DATABASE=postgres" -e "KONG_PG_HOST=kong-database" -e "KONG_PG_PASSWORD=kongpass" kong:latest kong migrations bootstrap

3. Start Kong Gateway
> docker run -it --name kong-gateway \
  --network=kongkong \
  -e "KONG_DATABASE=postgres" \
  -e "KONG_PG_HOST=kong-database" \
  -e "KONG_PG_USER=kong" \
  -e "KONG_PG_PASSWORD=kongpass" \
  -e "KONG_PROXY_ACCESS_LOG=/dev/stdout" \
  -e "KONG_ADMIN_ACCESS_LOG=/dev/stdout" \
  -e "KONG_PROXY_ERROR_LOG=/dev/stderr" \
  -e "KONG_ADMIN_ERROR_LOG=/dev/stderr" \
  -e "KONG_ADMIN_LISTEN=0.0.0.0:8001, 0.0.0.0:8444 ssl" \
  -p 8000:8000 \
  -p 8443:8443 \
  -p 127.0.0.1:8001:8001 \
  -p 127.0.0.1:8444:8444 \
  kong:latest

  OR:
  > docker run -it --name kong-gateway --network=kongkong -e "KONG_DATABASE=postgres" -e "KONG_PG_HOST=kong-database" -e "KONG_PG_USER=kong" -e "KONG_PG_PASSWORD=kongpass" -e "KONG_PROXY_ACCESS_LOG=/dev/stdout" -e "KONG_ADMIN_ACCESS_LOG=/dev/stdout" -e "KONG_PROXY_ERROR_LOG=/dev/stderr" -e "KONG_ADMIN_ERROR_LOG=/dev/stderr" -e "KONG_ADMIN_LISTEN=0.0.0.0:8001, 0.0.0.0:8444 ssl" -p 8000:8000 -p 8443:8443 -p 127.0.0.1:8001:8001 -p 127.0.0.1:8444:8444 kong:latest


## Clean Up Container
Stop Kong Gateway Container:
> docker kill kong-gateway

Stop Kong database Container:
> docker kill kong-database

Remove Kong Gateway Container:
> docker container rm kong-gateway

Remove Kong database Container:
> docker container rm kong-database

Remove Network:
> docker network rm kongkong

# TEST ON INSOMNIA
## FastAPI container running
1. Method: @GET
> localhost:3000/fastdb/showtables/{tb_name}

Example:
> localhost:3000/fastdb/showtables/tb_rank

2. Method: @DELETE
> localhost:3000/fastdb/delete_rank/{id}

Example:
> localhost:3000/fastdb/delete_rank/1

3. Method: @POST
> localhost:3000/fastdb/insert_rank/{item_id}?ranks={anyranks}&description={anydescription}

Example:
> localhost:3000/fastdb/insert_rank/1?ranks=kelinci&description=bebek

4. Method: @PUT
> localhost:3000/fastdb/update_rank/{item_id}?ranks={any_ranks}&description={anydescription}

Example:
> localhost:3000/fastdb/update_rank/2?ranks=buaya&description=rawa

## FastAPI and Kong container running
Use the path in kong.yml

General test:
> localhost:kong_port/path

Home service:
> localhost:8000/home

Show table list (@GET):
> localhost:8000/tablelist

Show rank table (@GET):
> localhost:8000/ranktable

Delete rank (@DELETE):
> localhost:8000/deleterank

Insert into table rank (@POST):
> localhost:8000/insertrank

Update table rank (@PUT):
> localhost:8000/updaterank

# DATABASE MANIPULATION
## Give user previlege.

I somehow want to give previlege to new user that I create, but it doesn't work.

So, I change the user into root instead.

They keep asking me for password when I already define the password on my main.py

But this is how to grant previlege to the user anyway.

Make sure you run the exec command above, and run this after succes entering the into MySQL.

> CREATE USER 'javier'@'localhost' IDENTIFIED WITH caching_sha2_password BY 'password';

> GRANT ALL PRIVILEGES ON * . * TO 'javier'@'localhost';

> FLUSH PRIVILEGES;

## Create Database

> CREATE DATABASE chessMatch;

## Use the Database
> use chessMatch;

## Create Table Rank

> CREATE TABLE IF NOT EXISTS tb_rank (id INT NOT NULL PRIMARY KEY, ranks VARCHAR(255), description TEXT) ENGINE=INNODB;

## Create Table Participant
> CREATE TABLE tb_participant (
    id int NOT NULL,
    first_name varchar(255),
    last_name varchar(255),
    address varchar(255),
    phone varchar(255),
    id_rank int NOT NULL,
    PRIMARY KEY (id),
    FOREIGN KEY (id_rank) REFERENCES tb_rank(id)
);

## Create Table Matches
> CREATE TABLE tb_matches (
    id int NOT NULL,
    id_participant_a int NOT NULL,
    id_participant_b int NOT NULL,
    result float NOT NULL,
    start varchar (10),
    end varchar (10),
    PRIMARY KEY (id),
    FOREIGN KEY (id_participant_a) REFERENCES tb_participant(id),
    FOREIGN KEY (id_participant_b) REFERENCES tb_participant(id)
);

## Show database
> show databases;

## Show tables
> show tables;

## Insert value into table.

Single value:
> INSERT INTO tb_rank VALUES ('1', 'Super Grand Master', 'ELO more than 2700');

Multi value:
> INSERT INTO tb_rank(id, ranks, description) VALUES('2', 'Grand Master (GM)', 'ELO between 2500-2700'), ('3', 'International Master (IM)', 'ELO between 2400-2500'), ('4', 'FIDE Master (FM)', 'ELO between 2300-4500'), ('5', 'FIDE Candidate Master (CM)', 'ELO between 2400-2500'), ('6', 'Candidate Master', 'ELO between 2000-2200'), ('7', 'Class A', 'ELO between 1800-2000'), ('8', 'Class B', 'ELO between 1600-1800'), ('9', 'Class C', 'ELO between 1400-1600'), ('10', 'Class D', 'ELO between 1200-1400'), ('11', 'Novices', 'ELO below 1200');


If you keep getting any error that must be came from the connection to MySQL.

So take a look on it, carefully.

# TEST RESULTS
## MYSQL Container
The CRUD on database directly on container is working fine and the data is saved even after turning off the container.

## FASTAPI Container
Functions that is working:
1. @app.get("/")

2. @app.get("/fastdb/view")

3. @app.get("/fastdb/showdb")

4. @app.get("/fastdb/showtables")

5. @app.get("/fastdb/showtables/{tb_name}")

6. @app.delete("/fastdb/delete_rank/{id}")

7. @app.post("/fastdb/insert_rank/{item_id}") : STATUS NOT CHECKED

8. @app.put("/fastdb/update_rank/{item_id}")

## Getting started

To make it easy for you to get started with GitLab, here's a list of recommended next steps.

Already a pro? Just edit this README.md and make it your own. Want to make it easy? [Use the template at the bottom](#editing-this-readme)!

## Add your files

- [ ] [Create](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#create-a-file) or [upload](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#upload-a-file) files
- [ ] [Add files using the command line](https://docs.gitlab.com/ee/gitlab-basics/add-file.html#add-a-file-using-the-command-line) or push an existing Git repository with the following command:

```
cd existing_repo
git remote add origin https://gitlab.com/mayna.datavizz/mysql.git
git branch -M main
git push -uf origin main
```

## Integrate with your tools

- [ ] [Set up project integrations](https://gitlab.com/mayna.datavizz/mysql/-/settings/integrations)

## Collaborate with your team

- [ ] [Invite team members and collaborators](https://docs.gitlab.com/ee/user/project/members/)
- [ ] [Create a new merge request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html)
- [ ] [Automatically close issues from merge requests](https://docs.gitlab.com/ee/user/project/issues/managing_issues.html#closing-issues-automatically)
- [ ] [Enable merge request approvals](https://docs.gitlab.com/ee/user/project/merge_requests/approvals/)
- [ ] [Automatically merge when pipeline succeeds](https://docs.gitlab.com/ee/user/project/merge_requests/merge_when_pipeline_succeeds.html)

## Test and Deploy

Use the built-in continuous integration in GitLab.

- [ ] [Get started with GitLab CI/CD](https://docs.gitlab.com/ee/ci/quick_start/index.html)
- [ ] [Analyze your code for known vulnerabilities with Static Application Security Testing(SAST)](https://docs.gitlab.com/ee/user/application_security/sast/)
- [ ] [Deploy to Kubernetes, Amazon EC2, or Amazon ECS using Auto Deploy](https://docs.gitlab.com/ee/topics/autodevops/requirements.html)
- [ ] [Use pull-based deployments for improved Kubernetes management](https://docs.gitlab.com/ee/user/clusters/agent/)
- [ ] [Set up protected environments](https://docs.gitlab.com/ee/ci/environments/protected_environments.html)

***

# Editing this README

When you're ready to make this README your own, just edit this file and use the handy template below (or feel free to structure it however you want - this is just a starting point!).  Thank you to [makeareadme.com](https://www.makeareadme.com/) for this template.

## Suggestions for a good README
Every project is different, so consider which of these sections apply to yours. The sections used in the template are suggestions for most open source projects. Also keep in mind that while a README can be too long and detailed, too long is better than too short. If you think your README is too long, consider utilizing another form of documentation rather than cutting out information.

## Name
Choose a self-explaining name for your project.

## Description
Let people know what your project can do specifically. Provide context and add a link to any reference visitors might be unfamiliar with. A list of Features or a Background subsection can also be added here. If there are alternatives to your project, this is a good place to list differentiating factors.

## Badges
On some READMEs, you may see small images that convey metadata, such as whether or not all the tests are passing for the project. You can use Shields to add some to your README. Many services also have instructions for adding a badge.

## Visuals
Depending on what you are making, it can be a good idea to include screenshots or even a video (you'll frequently see GIFs rather than actual videos). Tools like ttygif can help, but check out Asciinema for a more sophisticated method.

## Installation
Within a particular ecosystem, there may be a common way of installing things, such as using Yarn, NuGet, or Homebrew. However, consider the possibility that whoever is reading your README is a novice and would like more guidance. Listing specific steps helps remove ambiguity and gets people to using your project as quickly as possible. If it only runs in a specific context like a particular programming language version or operating system or has dependencies that have to be installed manually, also add a Requirements subsection.

## Usage
Use examples liberally, and show the expected output if you can. It's helpful to have inline the smallest example of usage that you can demonstrate, while providing links to more sophisticated examples if they are too long to reasonably include in the README.

## Support
Tell people where they can go to for help. It can be any combination of an issue tracker, a chat room, an email address, etc.

## Roadmap
If you have ideas for releases in the future, it is a good idea to list them in the README.

## Contributing
State if you are open to contributions and what your requirements are for accepting them.

For people who want to make changes to your project, it's helpful to have some documentation on how to get started. Perhaps there is a script that they should run or some environment variables that they need to set. Make these steps explicit. These instructions could also be useful to your future self.

You can also document commands to lint the code or run tests. These steps help to ensure high code quality and reduce the likelihood that the changes inadvertently break something. Having instructions for running tests is especially helpful if it requires external setup, such as starting a Selenium server for testing in a browser.

## Authors and acknowledgment
Show your appreciation to those who have contributed to the project.

## License
For open source projects, say how it is licensed.

## Project status
If you have run out of energy or time for your project, put a note at the top of the README saying that development has slowed down or stopped completely. Someone may choose to fork your project or volunteer to step in as a maintainer or owner, allowing your project to keep going. You can also make an explicit request for maintainers.
